blob: 897e6fcc94a195bd8b4493deee411ba9c6ba9f15 [file] [log] [blame]
Jonathan Niederc74c7202013-11-25 13:03:06 -08001# Test framework for git. See t/README for usage.
Junio C Hamanoe1970ce2005-05-13 22:50:32 -07002#
3# Copyright (c) 2005 Junio C Hamano
4#
Michal Sojka64b90322010-04-16 15:53:59 +02005# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 2 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see http://www.gnu.org/licenses/ .
Junio C Hamanoe1970ce2005-05-13 22:50:32 -070017
Junio C Hamano3c8f12c2012-06-24 22:01:35 -070018# Test the binaries we have just built. The tests are kept in
19# t/ subdirectory and are run in 'trash directory' subdirectory.
20if test -z "$TEST_DIRECTORY"
21then
22 # We allow tests to override this, in case they want to run tests
23 # outside of t/, e.g. for running tests on the test library
24 # itself.
25 TEST_DIRECTORY=$(pwd)
Felipe Contreras85176d72013-11-17 23:12:43 -050026else
27 # ensure that TEST_DIRECTORY is an absolute path so that it
28 # is valid even if the current working directory is changed
29 TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
Junio C Hamano3c8f12c2012-06-24 22:01:35 -070030fi
31if test -z "$TEST_OUTPUT_DIRECTORY"
32then
33 # Similarly, override this to store the test-results subdir
34 # elsewhere
35 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
36fi
37GIT_BUILD_DIR="$TEST_DIRECTORY"/..
38
Jeff Kingd0cc5792017-07-10 09:24:35 -040039# If we were built with ASAN, it may complain about leaks
40# of program-lifetime variables. Disable it by default to lower
41# the noise level. This needs to happen at the start of the script,
42# before we even do our "did we build git yet" check (since we don't
43# want that one to complain to stderr).
Jeff Kingbf1ce902017-07-10 09:24:39 -040044: ${ASAN_OPTIONS=detect_leaks=0:abort_on_error=1}
Jeff Kingd0cc5792017-07-10 09:24:35 -040045export ASAN_OPTIONS
46
Jeff King85b81b32017-09-05 09:04:04 -040047# If LSAN is in effect we _do_ want leak checking, but we still
48# want to abort so that we notice the problems.
49: ${LSAN_OPTIONS=abort_on_error=1}
50export LSAN_OPTIONS
51
Ramkumar Ramachandra2006f0a2012-09-17 22:36:19 +053052################################################################
53# It appears that people try to run tests without building...
54"$GIT_BUILD_DIR/git" >/dev/null
55if test $? != 1
56then
57 echo >&2 'error: you do not seem to have built git yet.'
58 exit 1
59fi
60
Junio C Hamano3c8f12c2012-06-24 22:01:35 -070061. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
62export PERL_PATH SHELL_PATH
63
Ramkumar Ramachandra4cde5192012-09-22 10:25:10 +053064# if --tee was passed, write the output not only to the terminal, but
65# additionally to the file test-results/$BASENAME.out, too.
66case "$GIT_TEST_TEE_STARTED, $* " in
67done,*)
68 # do not redirect again
69 ;;
Jeff King452320f2016-10-21 06:48:00 -040070*' --tee '*|*' --va'*|*' --verbose-log '*)
John Keeping2d14e132013-04-29 19:16:21 +010071 mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
72 BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
Jeff King452320f2016-10-21 06:48:00 -040073
74 # Make this filename available to the sub-process in case it is using
75 # --verbose-log.
76 GIT_TEST_TEE_OUTPUT_FILE=$BASE.out
77 export GIT_TEST_TEE_OUTPUT_FILE
78
79 # Truncate before calling "tee -a" to get rid of the results
80 # from any previous runs.
81 >"$GIT_TEST_TEE_OUTPUT_FILE"
82
Jeff King3f824e92017-12-08 05:47:22 -050083 (GIT_TEST_TEE_STARTED=done ${TEST_SHELL_PATH} "$0" "$@" 2>&1;
Jeff King452320f2016-10-21 06:48:00 -040084 echo $? >"$BASE.exit") | tee -a "$GIT_TEST_TEE_OUTPUT_FILE"
Jeff King925bdc92016-10-21 06:42:10 -040085 test "$(cat "$BASE.exit")" = 0
Ramkumar Ramachandra4cde5192012-09-22 10:25:10 +053086 exit
87 ;;
88esac
89
Junio C Hamanoe1970ce2005-05-13 22:50:32 -070090# For repeatability, reset the environment to known value.
Richard Hansend5c1b7c2015-06-17 17:11:21 -040091# TERM is sanitized below, after saving color control sequences.
Junio C Hamanoe1970ce2005-05-13 22:50:32 -070092LANG=C
Junio C Hamano899460f2005-10-09 21:58:02 -070093LC_ALL=C
Pavel Roskind9bdd392005-08-10 22:10:01 -040094PAGER=cat
Junio C Hamanoe1970ce2005-05-13 22:50:32 -070095TZ=UTC
Richard Hansend5c1b7c2015-06-17 17:11:21 -040096export LANG LC_ALL PAGER TZ
Eric Wong8ff99e72006-07-11 12:01:54 -070097EDITOR=:
Stefano Lattarini661bfd12012-03-02 19:48:36 +010098# A call to "unset" with no arguments causes at least Solaris 10
99# /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
100# deriving from the command substitution clustered with the other
101# ones.
Junio C Hamano3c8f12c2012-06-24 22:01:35 -0700102unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
Jonathan Nieder95a1d122011-03-15 05:10:45 -0500103 my @env = keys %ENV;
Jens Lehmann730477f2011-03-28 21:16:09 +0200104 my $ok = join("|", qw(
105 TRACE
106 DEBUG
Jens Lehmann730477f2011-03-28 21:16:09 +0200107 TEST
108 .*_TEST
109 PROVE
110 VALGRIND
René Scharfeac001282013-01-06 18:47:57 +0100111 UNZIP
Nguyễn Thái Ngọc Duyedb54082013-01-15 20:50:56 +0700112 PERF_
Jeff Kinge2a0ccc2014-05-22 05:28:50 -0400113 CURL_VERBOSE
Elia Pinto4527aa12016-09-05 10:24:42 +0000114 TRACE_CURL
Jens Lehmann730477f2011-03-28 21:16:09 +0200115 ));
116 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
Jonathan Nieder95a1d122011-03-15 05:10:45 -0500117 print join("\n", @vars);
118')
Genki Sky7976e902018-02-15 21:46:04 -0500119unset XDG_CACHE_HOME
Jeff King5adf84e2012-07-24 07:53:05 -0400120unset XDG_CONFIG_HOME
Benoit Person8bade1e2013-07-04 22:38:55 +0200121unset GITPERLLIB
Junio C Hamano29e55cd2006-02-10 19:11:23 -0800122GIT_AUTHOR_EMAIL=author@example.com
123GIT_AUTHOR_NAME='A U Thor'
Junio C Hamano29e55cd2006-02-10 19:11:23 -0800124GIT_COMMITTER_EMAIL=committer@example.com
125GIT_COMMITTER_NAME='C O Mitter'
Shawn O. Pearce8d0fc482007-02-04 00:45:47 -0500126GIT_MERGE_VERBOSITY=5
Junio C Hamanof8246282012-01-10 22:44:45 -0800127GIT_MERGE_AUTOEDIT=no
128export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
Junio C Hamano29e55cd2006-02-10 19:11:23 -0800129export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
130export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
Jonathan Niederd33738d2009-11-11 17:56:07 -0600131export EDITOR
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700132
Karsten Blees124647c2014-07-12 02:03:01 +0200133# Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
134GIT_TRACE_BARE=1
135export GIT_TRACE_BARE
136
Ben Peart4cb54d02018-09-18 23:29:35 +0000137check_var_migration () {
Junio C Hamano4231d1b2018-09-20 11:43:43 -0700138 # the warnings and hints given from this helper depends
139 # on end-user settings, which will disrupt the self-test
140 # done on the test framework itself.
141 case "$GIT_TEST_FRAMEWORK_SELFTEST" in
142 t) return ;;
143 esac
144
Ben Peart4cb54d02018-09-18 23:29:35 +0000145 old_name=$1 new_name=$2
146 eval "old_isset=\${${old_name}:+isset}"
147 eval "new_isset=\${${new_name}:+isset}"
Junio C Hamano4231d1b2018-09-20 11:43:43 -0700148
Ben Peart4cb54d02018-09-18 23:29:35 +0000149 case "$old_isset,$new_isset" in
150 isset,)
151 echo >&2 "warning: $old_name is now $new_name"
152 echo >&2 "hint: set $new_name too during the transition period"
153 eval "$new_name=\$$old_name"
154 ;;
155 isset,isset)
156 # do this later
157 # echo >&2 "warning: $old_name is now $new_name"
158 # echo >&2 "hint: remove $old_name"
159 ;;
160 esac
161}
162
163check_var_migration GIT_FSMONITOR_TEST GIT_TEST_FSMONITOR
Ben Peart1f357b02018-09-18 23:29:36 +0000164check_var_migration TEST_GIT_INDEX_VERSION GIT_TEST_INDEX_VERSION
Ben Peart5765d972018-09-18 23:29:37 +0000165check_var_migration GIT_FORCE_PRELOAD_TEST GIT_TEST_PRELOAD_INDEX
Ben Peart1f357b02018-09-18 23:29:36 +0000166
167# Use specific version of the index file format
168if test -n "${GIT_TEST_INDEX_VERSION:+isset}"
Thomas Gummerer5d9fc882014-02-23 21:49:58 +0100169then
Ben Peart1f357b02018-09-18 23:29:36 +0000170 GIT_INDEX_VERSION="$GIT_TEST_INDEX_VERSION"
Thomas Gummerer5d9fc882014-02-23 21:49:58 +0100171 export GIT_INDEX_VERSION
172fi
173
Elia Pintoa731fa92012-09-14 09:54:22 -0700174# Add libc MALLOC and MALLOC_PERTURB test
175# only if we are not executing the test with valgrind
Junio C Hamano1b3185f2012-09-14 20:38:24 -0700176if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
René Scharfeee1431b2012-09-26 22:16:39 +0200177 test -n "$TEST_NO_MALLOC_CHECK"
Junio C Hamano1b3185f2012-09-14 20:38:24 -0700178then
179 setup_malloc_check () {
180 : nothing
181 }
182 teardown_malloc_check () {
183 : nothing
184 }
185else
186 setup_malloc_check () {
187 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
188 export MALLOC_CHECK_ MALLOC_PERTURB_
189 }
190 teardown_malloc_check () {
191 unset MALLOC_CHECK_ MALLOC_PERTURB_
192 }
193fi
Elia Pintoa731fa92012-09-14 09:54:22 -0700194
Junio C Hamano886a3902007-04-24 11:21:47 -0700195# Protect ourselves from common misconfiguration to export
196# CDPATH into the environment
197unset CDPATH
198
Bert Wesarg5565f472009-11-18 17:15:19 +0100199unset GREP_OPTIONS
René Scharfeac001282013-01-06 18:47:57 +0100200unset UNZIP
Bert Wesarg5565f472009-11-18 17:15:19 +0100201
Robin Rosenberg3d5c0cc2006-09-23 00:35:20 +0200202case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
Ramsay Jones1c0cc752012-09-01 19:11:49 +01002031|2|true)
Jeff King025232e2015-03-13 00:50:56 -0400204 GIT_TRACE=4
Ramsay Jones1c0cc752012-09-01 19:11:49 +0100205 ;;
Christian Couder6ce4e612006-09-02 18:23:48 +0200206esac
207
Junio C Hamanocd3c0952009-09-20 11:10:14 -0700208# Convenience
209#
Charles Bailey5555a2a2017-11-12 15:25:23 +0000210# A regexp to match 5, 35 and 40 hexdigits
Junio C Hamanocd3c0952009-09-20 11:10:14 -0700211_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
Charles Bailey5555a2a2017-11-12 15:25:23 +0000212_x35="$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
213_x40="$_x35$_x05"
Junio C Hamanocd3c0952009-09-20 11:10:14 -0700214
Junio C Hamano3749fde2011-04-23 22:34:13 -0700215# Zero SHA-1
216_z40=0000000000000000000000000000000000000000
217
brian m. carlsonbd981d52018-05-13 02:24:14 +0000218OID_REGEX="$_x40"
brian m. carlson198857b2018-05-13 02:24:12 +0000219ZERO_OID=$_z40
Nguyễn Thái Ngọc Duyf9e7d9f2016-07-16 07:06:24 +0200220EMPTY_TREE=4b825dc642cb6eb9a060e54bf8d69288fbee4904
Nguyễn Thái Ngọc Duy378932d2016-07-16 07:06:25 +0200221EMPTY_BLOB=e69de29bb2d1d6434b8b29ae775ad8c2e48c5391
Nguyễn Thái Ngọc Duyf9e7d9f2016-07-16 07:06:24 +0200222
Junio C Hamano3f4ab622011-08-08 11:51:00 -0700223# Line feed
224LF='
225'
226
Jeff Kinga42643a2014-12-15 18:15:20 -0500227# UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
228# when case-folding filenames
229u200c=$(printf '\342\200\214')
230
brian m. carlsonbd981d52018-05-13 02:24:14 +0000231export _x05 _x35 _x40 _z40 LF u200c EMPTY_TREE EMPTY_BLOB ZERO_OID OID_REGEX
Thomas Rast342e9ef2012-02-17 11:25:09 +0100232
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700233# Each test should start with something like this, after copyright notices:
234#
235# test_description='Description of this test...
236# This test checks if command xyzzy does the right thing...
237# '
238# . ./test-lib.sh
Richard Hansend5c1b7c2015-06-17 17:11:21 -0400239test "x$TERM" != "xdumb" && (
Richard Hansenca92a662015-06-17 15:06:25 -0400240 test -t 1 &&
241 tput bold >/dev/null 2>&1 &&
242 tput setaf 1 >/dev/null 2>&1 &&
243 tput sgr0 >/dev/null 2>&1
244 ) &&
245 color=t
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700246
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700247while test "$#" -ne 0
248do
249 case "$1" in
250 -d|--d|--de|--deb|--debu|--debug)
251 debug=t; shift ;;
Junio C Hamano886856a2005-05-14 00:24:27 -0700252 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
253 immediate=t; shift ;;
Lea Wiemann5e2c08c2008-06-17 03:29:02 +0200254 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
Junio C Hamano91e80b92009-02-18 11:17:27 -0800255 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
Ilya Bobyr0445e6f2014-04-30 02:50:44 -0700256 -r)
257 shift; test "$#" -ne 0 || {
258 echo 'error: -r requires an argument' >&2;
259 exit 1;
260 }
261 run_list=$1; shift ;;
262 --run=*)
SZEDER Gábor0ff74102016-04-22 22:32:21 +0200263 run_list=${1#--*=}; shift ;;
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700264 -h|--h|--he|--hel|--help)
Michele Ballabio570f3222007-11-10 15:17:25 +0100265 help=t; shift ;;
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700266 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
267 verbose=t; shift ;;
Thomas Rastff09af32013-06-23 20:12:56 +0200268 --verbose-only=*)
SZEDER Gábor0ff74102016-04-22 22:32:21 +0200269 verbose_only=${1#--*=}
Thomas Rastff09af32013-06-23 20:12:56 +0200270 shift ;;
Pierre Habouzit1ece1272007-10-24 22:03:39 +0200271 -q|--q|--qu|--qui|--quie|--quiet)
Ævar Arnfjörð Bjarmason092c4332010-07-31 16:40:05 +0000272 # Ignore --quiet under a TAP::Harness. Saying how many tests
273 # passed without the ok/not ok details is always an error.
274 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
Matthew Ogilviee4597aa2009-12-02 22:14:06 -0700275 --with-dashes)
276 with_dashes=t; shift ;;
Pierre Habouzit55db1df2007-10-24 22:03:38 +0200277 --no-color)
Clemens Buchacherfaa4bc32008-02-27 20:28:45 +0100278 color=; shift ;;
Johannes Schindelin4e1be632009-02-04 00:25:59 +0100279 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
Thomas Rast952af352013-03-31 10:00:16 +0200280 valgrind=memcheck
281 shift ;;
282 --valgrind=*)
SZEDER Gábor0ff74102016-04-22 22:32:21 +0200283 valgrind=${1#--*=}
Thomas Rast952af352013-03-31 10:00:16 +0200284 shift ;;
Thomas Rast5dfc3682013-06-23 20:12:57 +0200285 --valgrind-only=*)
SZEDER Gábor0ff74102016-04-22 22:32:21 +0200286 valgrind_only=${1#--*=}
Thomas Rast5dfc3682013-06-23 20:12:57 +0200287 shift ;;
Johannes Schindelin44138552009-02-04 00:26:12 +0100288 --tee)
289 shift ;; # was handled already
Jeff Kingf423ef52009-08-09 04:39:45 -0400290 --root=*)
SZEDER Gábor0ff74102016-04-22 22:32:21 +0200291 root=${1#--*=}
Jeff Kingf423ef52009-08-09 04:39:45 -0400292 shift ;;
Jeff Kingbb79af92015-03-20 06:05:48 -0400293 --chain-lint)
294 GIT_TEST_CHAIN_LINT=1
295 shift ;;
296 --no-chain-lint)
297 GIT_TEST_CHAIN_LINT=0
298 shift ;;
Jeff Kinga136f6d2014-10-10 02:47:27 -0400299 -x)
SZEDER Gábor5fc98e72018-02-24 00:39:42 +0100300 # Some test scripts can't be reliably traced with '-x',
301 # unless the test is run with a Bash version supporting
302 # BASH_XTRACEFD (introduced in Bash v4.1). Check whether
303 # this test is marked as such, and ignore '-x' if it
304 # isn't executed with a suitable Bash version.
305 if test -z "$test_untraceable" || {
306 test -n "$BASH_VERSION" && {
307 test ${BASH_VERSINFO[0]} -gt 4 || {
308 test ${BASH_VERSINFO[0]} -eq 4 &&
309 test ${BASH_VERSINFO[1]} -ge 1
310 }
311 }
312 }
313 then
314 trace=t
315 else
316 echo >&2 "warning: ignoring -x; '$0' is untraceable without BASH_XTRACEFD"
317 fi
Jeff Kinga136f6d2014-10-10 02:47:27 -0400318 shift ;;
Jeff King452320f2016-10-21 06:48:00 -0400319 --verbose-log)
320 verbose_log=t
321 shift ;;
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700322 *)
Clemens Buchacher1f729dc2009-06-01 14:14:40 +0200323 echo "error: unknown test option '$1'" >&2; exit 1 ;;
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700324 esac
325done
326
Thomas Rast26a07302013-10-19 23:06:07 +0200327if test -n "$valgrind_only"
Thomas Rast5dfc3682013-06-23 20:12:57 +0200328then
329 test -z "$valgrind" && valgrind=memcheck
330 test -z "$verbose" && verbose_only="$valgrind_only"
331elif test -n "$valgrind"
332then
Jeff King88c6e9d2017-09-05 09:03:54 -0400333 test -z "$verbose_log" && verbose=t
Thomas Rast5dfc3682013-06-23 20:12:57 +0200334fi
Thomas Rast952af352013-03-31 10:00:16 +0200335
Jeff Kingf5ba2de2017-12-08 05:47:17 -0500336if test -n "$trace" && test -z "$verbose_log"
337then
338 verbose=t
339fi
340
Richard Hansenca92a662015-06-17 15:06:25 -0400341if test -n "$color"
342then
Richard Hansend5c1b7c2015-06-17 17:11:21 -0400343 # Save the color control sequences now rather than run tput
344 # each time say_color() is called. This is done for two
345 # reasons:
346 # * TERM will be changed to dumb
347 # * HOME will be changed to a temporary directory and tput
348 # might need to read ~/.terminfo from the original HOME
349 # directory to get the control sequences
350 # Note: This approach assumes the control sequences don't end
351 # in a newline for any terminal of interest (command
352 # substitutions strip trailing newlines). Given that most
353 # (all?) terminals in common use are related to ECMA-48, this
354 # shouldn't be a problem.
355 say_color_error=$(tput bold; tput setaf 1) # bold red
356 say_color_skip=$(tput setaf 4) # blue
357 say_color_warn=$(tput setaf 3) # brown/yellow
358 say_color_pass=$(tput setaf 2) # green
359 say_color_info=$(tput setaf 6) # cyan
360 say_color_reset=$(tput sgr0)
361 say_color_="" # no formatting for normal text
Richard Hansenca92a662015-06-17 15:06:25 -0400362 say_color () {
Richard Hansend5c1b7c2015-06-17 17:11:21 -0400363 test -z "$1" && test -n "$quiet" && return
364 eval "say_color_color=\$say_color_$1"
Richard Hansenca92a662015-06-17 15:06:25 -0400365 shift
Richard Hansend5c1b7c2015-06-17 17:11:21 -0400366 printf "%s\\n" "$say_color_color$*$say_color_reset"
Richard Hansenca92a662015-06-17 15:06:25 -0400367 }
368else
369 say_color() {
370 test -z "$1" && test -n "$quiet" && return
371 shift
372 printf "%s\n" "$*"
373 }
374fi
375
Richard Hansend5c1b7c2015-06-17 17:11:21 -0400376TERM=dumb
377export TERM
378
Pierre Habouzit55db1df2007-10-24 22:03:38 +0200379error () {
380 say_color error "error: $*"
Clemens Buchacher6e7b5aa2009-06-01 14:14:41 +0200381 GIT_EXIT_OK=t
Pierre Habouzit55db1df2007-10-24 22:03:38 +0200382 exit 1
383}
384
385say () {
386 say_color info "$*"
387}
388
Jeff King614fe012016-10-22 00:45:06 -0400389if test -n "$HARNESS_ACTIVE"
390then
391 if test "$verbose" = t || test -n "$verbose_only"
392 then
393 printf 'Bail out! %s\n' \
394 'verbose mode forbidden under TAP harness; try --verbose-log'
395 exit 1
396 fi
397fi
398
Michele Ballabio570f3222007-11-10 15:17:25 +0100399test "${test_description}" != "" ||
400error "Test script did not set test_description."
401
402if test "$help" = "t"
403then
Uwe Storbeckcb1aefd2014-03-18 01:14:11 +0100404 printf '%s\n' "$test_description"
Michele Ballabio570f3222007-11-10 15:17:25 +0100405 exit 0
406fi
407
Pavel Roskin4d9d62f2005-08-10 23:56:21 -0400408exec 5>&1
Jeff King781f76b2011-12-15 01:55:29 -0500409exec 6<&0
SZEDER Gábor4ecae3c2017-03-18 17:13:59 +0100410exec 7>&2
Jeff King452320f2016-10-21 06:48:00 -0400411if test "$verbose_log" = "t"
412then
413 exec 3>>"$GIT_TEST_TEE_OUTPUT_FILE" 4>&3
414elif test "$verbose" = "t"
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700415then
416 exec 4>&2 3>&1
417else
418 exec 4>/dev/null 3>/dev/null
419fi
420
Jeff Kingd88785e2016-05-11 09:44:04 -0400421# Send any "-x" output directly to stderr to avoid polluting tests
422# which capture stderr. We can do this unconditionally since it
423# has no effect if tracing isn't turned on.
424#
425# Note that this sets up the trace fd as soon as we assign the variable, so it
426# must come after the creation of descriptor 4 above. Likewise, we must never
427# unset this, as it has the side effect of closing descriptor 4, which we
428# use to show verbose tests to the user.
429#
430# Note also that we don't need or want to export it. The tracing is local to
431# this shell, and we would not want to influence any shells we exec.
432BASH_XTRACEFD=4
433
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700434test_failure=0
435test_count=0
Junio C Hamano41ac4142008-02-01 01:50:53 -0800436test_fixed=0
437test_broken=0
Sverre Rabbelier2d84e9f2008-06-08 16:04:33 +0200438test_success=0
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700439
Ævar Arnfjörð Bjarmasond998bd42010-06-24 17:44:46 +0000440test_external_has_tap=0
441
Clemens Buchacherfaa4bc32008-02-27 20:28:45 +0100442die () {
Clemens Buchacher6e7b5aa2009-06-01 14:14:41 +0200443 code=$?
444 if test -n "$GIT_EXIT_OK"
445 then
446 exit $code
447 else
448 echo >&5 "FATAL: Unexpected exit with code $code"
449 exit 1
450 fi
Clemens Buchacherfaa4bc32008-02-27 20:28:45 +0100451}
452
Clemens Buchacher6e7b5aa2009-06-01 14:14:41 +0200453GIT_EXIT_OK=
Markus Heidelberg35641312009-01-20 00:43:26 +0100454trap 'die' EXIT
Jeff Kingda706542015-03-13 00:48:48 -0400455trap 'exit $?' INT
Pavel Roskin41184272005-08-11 12:00:40 -0400456
Thomas Rast12a29b12012-02-17 11:25:08 +0100457# The user-facing functions are loaded from a separate file so that
458# test_perf subshells can have them too
Junio C Hamano3c8f12c2012-06-24 22:01:35 -0700459. "$TEST_DIRECTORY/test-lib-functions.sh"
Jonathan Nieder05236a52010-10-17 02:36:58 +0800460
Junio C Hamano886856a2005-05-14 00:24:27 -0700461# You are not expected to call test_ok_ and test_failure_ directly, use
Torstein Hegge3fa36662013-10-27 10:56:33 +0100462# the test_expect_* functions instead.
Junio C Hamano886856a2005-05-14 00:24:27 -0700463
464test_ok_ () {
Johannes Sixtd5d9de12009-02-05 20:59:27 +0100465 test_success=$(($test_success + 1))
Thomas Rast633fe502013-10-19 23:06:08 +0200466 say_color "" "ok $test_count - $@"
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700467}
468
Junio C Hamano886856a2005-05-14 00:24:27 -0700469test_failure_ () {
Johannes Sixtd5d9de12009-02-05 20:59:27 +0100470 test_failure=$(($test_failure + 1))
Thomas Rast633fe502013-10-19 23:06:08 +0200471 say_color error "not ok $test_count - $1"
Junio C Hamanobf0dd8a2005-07-22 19:09:34 -0700472 shift
Uwe Storbeckcb1aefd2014-03-18 01:14:11 +0100473 printf '%s\n' "$*" | sed -e 's/^/# /'
Clemens Buchacher6e7b5aa2009-06-01 14:14:41 +0200474 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
Junio C Hamano886856a2005-05-14 00:24:27 -0700475}
476
Junio C Hamano41ac4142008-02-01 01:50:53 -0800477test_known_broken_ok_ () {
Junio C Hamano41ac4142008-02-01 01:50:53 -0800478 test_fixed=$(($test_fixed+1))
Thomas Rast633fe502013-10-19 23:06:08 +0200479 say_color error "ok $test_count - $@ # TODO known breakage vanished"
Junio C Hamano41ac4142008-02-01 01:50:53 -0800480}
481
482test_known_broken_failure_ () {
Junio C Hamano41ac4142008-02-01 01:50:53 -0800483 test_broken=$(($test_broken+1))
Thomas Rast633fe502013-10-19 23:06:08 +0200484 say_color warn "not ok $test_count - $@ # TODO known breakage"
Junio C Hamano41ac4142008-02-01 01:50:53 -0800485}
Junio C Hamano886856a2005-05-14 00:24:27 -0700486
487test_debug () {
Junio C Hamano8e832eb2005-08-10 22:53:27 -0700488 test "$debug" = "" || eval "$1"
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700489}
490
Thomas Raste6a6ddc2013-06-18 14:25:58 +0200491match_pattern_list () {
492 arg="$1"
493 shift
494 test -z "$*" && return 1
495 for pattern_
496 do
497 case "$arg" in
498 $pattern_)
499 return 0
500 esac
501 done
502 return 1
503}
504
Ilya Bobyr0445e6f2014-04-30 02:50:44 -0700505match_test_selector_list () {
506 title="$1"
507 shift
508 arg="$1"
509 shift
510 test -z "$1" && return 0
511
512 # Both commas and whitespace are accepted as separators.
513 OLDIFS=$IFS
514 IFS=' ,'
515 set -- $1
516 IFS=$OLDIFS
517
518 # If the first selector is negative we include by default.
519 include=
520 case "$1" in
521 !*) include=t ;;
522 esac
523
524 for selector
525 do
526 orig_selector=$selector
527
528 positive=t
529 case "$selector" in
530 !*)
531 positive=
532 selector=${selector##?}
533 ;;
534 esac
535
536 test -z "$selector" && continue
537
538 case "$selector" in
539 *-*)
540 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
541 then
542 echo "error: $title: invalid non-numeric in range" \
543 "start: '$orig_selector'" >&2
544 exit 1
545 fi
546 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
547 then
548 echo "error: $title: invalid non-numeric in range" \
549 "end: '$orig_selector'" >&2
550 exit 1
551 fi
552 ;;
553 *)
554 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
555 then
556 echo "error: $title: invalid non-numeric in test" \
557 "selector: '$orig_selector'" >&2
558 exit 1
559 fi
560 esac
561
562 # Short cut for "obvious" cases
563 test -z "$include" && test -z "$positive" && continue
564 test -n "$include" && test -n "$positive" && continue
565
566 case "$selector" in
567 -*)
568 if test $arg -le ${selector#-}
569 then
570 include=$positive
571 fi
572 ;;
573 *-)
574 if test $arg -ge ${selector%-}
575 then
576 include=$positive
577 fi
578 ;;
579 *-*)
580 if test ${selector%%-*} -le $arg \
581 && test $arg -le ${selector#*-}
582 then
583 include=$positive
584 fi
585 ;;
586 *)
587 if test $arg -eq $selector
588 then
589 include=$positive
590 fi
591 ;;
592 esac
593 done
594
595 test -n "$include"
596}
597
Thomas Rastff09af32013-06-23 20:12:56 +0200598maybe_teardown_verbose () {
599 test -z "$verbose_only" && return
600 exec 4>/dev/null 3>/dev/null
601 verbose=
602}
603
604last_verbose=t
605maybe_setup_verbose () {
606 test -z "$verbose_only" && return
Thomas Rast26a07302013-10-19 23:06:07 +0200607 if match_pattern_list $test_count $verbose_only
Thomas Rastff09af32013-06-23 20:12:56 +0200608 then
609 exec 4>&2 3>&1
610 # Emit a delimiting blank line when going from
611 # non-verbose to verbose. Within verbose mode the
612 # delimiter is printed by test_expect_*. The choice
613 # of the initial $last_verbose is such that before
614 # test 1, we do not print it.
615 test -z "$last_verbose" && echo >&3 ""
616 verbose=t
617 else
618 exec 4>/dev/null 3>/dev/null
619 verbose=
620 fi
621 last_verbose=$verbose
622}
623
Thomas Rast5dfc3682013-06-23 20:12:57 +0200624maybe_teardown_valgrind () {
625 test -z "$GIT_VALGRIND" && return
626 GIT_VALGRIND_ENABLED=
627}
628
629maybe_setup_valgrind () {
630 test -z "$GIT_VALGRIND" && return
Thomas Rast26a07302013-10-19 23:06:07 +0200631 if test -z "$valgrind_only"
Thomas Rast5dfc3682013-06-23 20:12:57 +0200632 then
633 GIT_VALGRIND_ENABLED=t
634 return
635 fi
636 GIT_VALGRIND_ENABLED=
637 if match_pattern_list $test_count $valgrind_only
638 then
639 GIT_VALGRIND_ENABLED=t
640 fi
641}
642
Jeff King9b5fe782015-08-06 01:33:57 -0400643want_trace () {
Jeff Kingf5ba2de2017-12-08 05:47:17 -0500644 test "$trace" = t && {
645 test "$verbose" = t || test "$verbose_log" = t
646 }
Jeff King9b5fe782015-08-06 01:33:57 -0400647}
648
Jeff Kinga136f6d2014-10-10 02:47:27 -0400649# This is a separate function because some tests use
650# "return" to end a test_expect_success block early
651# (and we want to make sure we run any cleanup like
652# "set +x").
653test_eval_inner_ () {
654 # Do not add anything extra (including LF) after '$*'
655 eval "
Jeff King9b5fe782015-08-06 01:33:57 -0400656 want_trace && set -x
Jeff Kinga136f6d2014-10-10 02:47:27 -0400657 $*"
658}
659
Jonathan Niedera7c58f22011-08-08 03:17:09 +0200660test_eval_ () {
Jeff King90c8a1d2017-12-08 05:47:08 -0500661 # If "-x" tracing is in effect, then we want to avoid polluting stderr
662 # with non-test commands. But once in "set -x" mode, we cannot prevent
Jeff Kinga136f6d2014-10-10 02:47:27 -0400663 # the shell from printing the "set +x" to turn it off (nor the saving
664 # of $? before that). But we can make sure that the output goes to
665 # /dev/null.
666 #
Jeff King90c8a1d2017-12-08 05:47:08 -0500667 # There are a few subtleties here:
668 #
669 # - we have to redirect descriptor 4 in addition to 2, to cover
670 # BASH_XTRACEFD
671 #
672 # - the actual eval has to come before the redirection block (since
673 # it needs to see descriptor 4 to set up its stderr)
674 #
675 # - likewise, any error message we print must be outside the block to
676 # access descriptor 4
677 #
678 # - checking $? has to come immediately after the eval, but it must
679 # be _inside_ the block to avoid polluting the "set -x" output
680 #
681
682 test_eval_inner_ "$@" </dev/null >&3 2>&4
Jeff Kinga136f6d2014-10-10 02:47:27 -0400683 {
Jeff Kinga136f6d2014-10-10 02:47:27 -0400684 test_eval_ret_=$?
Jeff King9b5fe782015-08-06 01:33:57 -0400685 if want_trace
Jeff Kinga136f6d2014-10-10 02:47:27 -0400686 then
687 set +x
Jeff Kinga136f6d2014-10-10 02:47:27 -0400688 fi
Jeff King90c8a1d2017-12-08 05:47:08 -0500689 } 2>/dev/null 4>&2
690
691 if test "$test_eval_ret_" != 0 && want_trace
692 then
693 say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
694 fi
Jeff Kinga136f6d2014-10-10 02:47:27 -0400695 return $test_eval_ret_
Jonathan Niedera7c58f22011-08-08 03:17:09 +0200696}
697
Pavel Roskin4d9d62f2005-08-10 23:56:21 -0400698test_run_ () {
Jonathan Niederb6b0afd2010-05-06 03:41:10 -0500699 test_cleanup=:
Junio C Hamanob5867442011-06-27 11:02:22 -0700700 expecting_failure=$2
Jeff Kingbb79af92015-03-20 06:05:48 -0400701
Jeff King92b269f2015-04-22 16:09:57 -0400702 if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
Jeff King2a01ef82015-08-06 01:31:47 -0400703 # turn off tracing for this test-eval, as it simply creates
704 # confusing noise in the "-x" output
705 trace_tmp=$trace
706 trace=
Jeff Kingbb79af92015-03-20 06:05:48 -0400707 # 117 is magic because it is unlikely to match the exit
708 # code of other programs
Eric Sunshine878f9882018-07-11 02:46:33 -0400709 if $(printf '%s\n' "$1" | sed -f "$GIT_BUILD_DIR/t/chainlint.sed" | grep -q '?![A-Z][A-Z]*?!') ||
710 test "OK-117" != "$(test_eval_ "(exit 117) && $1${LF}${LF}echo OK-\$?" 3>&1)"
Junio C Hamano99a64e42017-03-22 22:43:18 -0700711 then
712 error "bug in the test script: broken &&-chain or run-away HERE-DOC: $1"
Jeff Kingbb79af92015-03-20 06:05:48 -0400713 fi
Jeff King2a01ef82015-08-06 01:31:47 -0400714 trace=$trace_tmp
Jeff Kingbb79af92015-03-20 06:05:48 -0400715 fi
716
Thomas Rasta57397b2013-06-17 11:18:46 +0200717 setup_malloc_check
Jonathan Niedera7c58f22011-08-08 03:17:09 +0200718 test_eval_ "$1"
Jonathan Niederb6b0afd2010-05-06 03:41:10 -0500719 eval_ret=$?
Thomas Rasta57397b2013-06-17 11:18:46 +0200720 teardown_malloc_check
Junio C Hamanob5867442011-06-27 11:02:22 -0700721
Jeff Kinga136f6d2014-10-10 02:47:27 -0400722 if test -z "$immediate" || test $eval_ret = 0 ||
723 test -n "$expecting_failure" && test "$test_cleanup" != ":"
Junio C Hamanob5867442011-06-27 11:02:22 -0700724 then
Junio C Hamano1b3185f2012-09-14 20:38:24 -0700725 setup_malloc_check
Jonathan Niedera7c58f22011-08-08 03:17:09 +0200726 test_eval_ "$test_cleanup"
Junio C Hamano1b3185f2012-09-14 20:38:24 -0700727 teardown_malloc_check
Junio C Hamanob5867442011-06-27 11:02:22 -0700728 fi
Ramsay Jones1c0cc752012-09-01 19:11:49 +0100729 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
730 then
Ævar Arnfjörð Bjarmason57e15382010-06-24 17:44:47 +0000731 echo ""
732 fi
Jonathan Niederaa0bcf92011-08-08 03:15:34 +0200733 return "$eval_ret"
Pavel Roskin4d9d62f2005-08-10 23:56:21 -0400734}
735
Thomas Rastae753422013-06-18 14:25:59 +0200736test_start_ () {
Johannes Sixt8586f982009-02-05 21:20:56 +0100737 test_count=$(($test_count+1))
Thomas Rastff09af32013-06-23 20:12:56 +0200738 maybe_setup_verbose
Thomas Rast5dfc3682013-06-23 20:12:57 +0200739 maybe_setup_valgrind
Thomas Rastae753422013-06-18 14:25:59 +0200740}
741
742test_finish_ () {
743 echo >&3 ""
Thomas Rast5dfc3682013-06-23 20:12:57 +0200744 maybe_teardown_valgrind
Thomas Rastff09af32013-06-23 20:12:56 +0200745 maybe_teardown_verbose
Thomas Rastae753422013-06-18 14:25:59 +0200746}
747
748test_skip () {
Junio C Hamano04ece592006-12-28 17:58:00 -0800749 to_skip=
Ilya Bobyref2ac682014-04-30 02:50:43 -0700750 skipped_reason=
Thomas Raste6a6ddc2013-06-18 14:25:58 +0200751 if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
752 then
753 to_skip=t
Ilya Bobyref2ac682014-04-30 02:50:43 -0700754 skipped_reason="GIT_SKIP_TESTS"
Thomas Raste6a6ddc2013-06-18 14:25:58 +0200755 fi
Jonathan Nieder05236a52010-10-17 02:36:58 +0800756 if test -z "$to_skip" && test -n "$test_prereq" &&
757 ! test_have_prereq "$test_prereq"
Johannes Sixta7bb3942009-03-01 21:04:46 +0100758 then
759 to_skip=t
Ilya Bobyref2ac682014-04-30 02:50:43 -0700760
Jonathan Nieder07431fc2010-08-24 02:34:10 -0500761 of_prereq=
Jonathan Nieder05236a52010-10-17 02:36:58 +0800762 if test "$missing_prereq" != "$test_prereq"
Jonathan Nieder07431fc2010-08-24 02:34:10 -0500763 then
Jonathan Nieder05236a52010-10-17 02:36:58 +0800764 of_prereq=" of $test_prereq"
Jonathan Nieder07431fc2010-08-24 02:34:10 -0500765 fi
Ilya Bobyref2ac682014-04-30 02:50:43 -0700766 skipped_reason="missing $missing_prereq${of_prereq}"
767 fi
Ilya Bobyr0445e6f2014-04-30 02:50:44 -0700768 if test -z "$to_skip" && test -n "$run_list" &&
769 ! match_test_selector_list '--run' $test_count "$run_list"
770 then
771 to_skip=t
772 skipped_reason="--run"
773 fi
Jonathan Nieder07431fc2010-08-24 02:34:10 -0500774
Ilya Bobyref2ac682014-04-30 02:50:43 -0700775 case "$to_skip" in
776 t)
Thomas Rast633fe502013-10-19 23:06:08 +0200777 say_color skip >&3 "skipping test: $@"
Ilya Bobyref2ac682014-04-30 02:50:43 -0700778 say_color skip "ok $test_count # skip $1 ($skipped_reason)"
Junio C Hamano04ece592006-12-28 17:58:00 -0800779 : true
780 ;;
781 *)
782 false
783 ;;
784 esac
785}
786
Thomas Rast342e9ef2012-02-17 11:25:09 +0100787# stub; perf-lib overrides it
788test_at_end_hook_ () {
789 :
790}
791
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700792test_done () {
Clemens Buchacher6e7b5aa2009-06-01 14:14:41 +0200793 GIT_EXIT_OK=t
Sverre Rabbelier2d84e9f2008-06-08 16:04:33 +0200794
Ramsay Jones1c0cc752012-09-01 19:11:49 +0100795 if test -z "$HARNESS_ACTIVE"
796 then
Thomas Rast342e9ef2012-02-17 11:25:09 +0100797 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
Ævar Arnfjörð Bjarmason8ef1abe2010-08-11 19:37:31 +0000798 mkdir -p "$test_results_dir"
Felipe Contrerasdd784782012-11-04 03:13:33 +0100799 base=${0##*/}
Jeff King5c885c12016-08-30 04:43:57 -0400800 test_results_path="$test_results_dir/${base%.sh}.counts"
Ævar Arnfjörð Bjarmason8ef1abe2010-08-11 19:37:31 +0000801
Jeff King5c885c12016-08-30 04:43:57 -0400802 cat >"$test_results_path" <<-EOF
Mathias Lafeldtc54e6be2011-04-29 14:30:30 +0200803 total $test_count
804 success $test_success
805 fixed $test_fixed
806 broken $test_broken
807 failed $test_failure
808
809 EOF
Ævar Arnfjörð Bjarmason8ef1abe2010-08-11 19:37:31 +0000810 fi
Junio C Hamano41ac4142008-02-01 01:50:53 -0800811
812 if test "$test_fixed" != 0
813 then
Thomas Rast633fe502013-10-19 23:06:08 +0200814 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
Junio C Hamano41ac4142008-02-01 01:50:53 -0800815 fi
816 if test "$test_broken" != 0
817 then
Thomas Rast633fe502013-10-19 23:06:08 +0200818 say_color warn "# still have $test_broken known breakage(s)"
Adam Spiersb73d9a22012-12-16 18:28:15 +0000819 fi
820 if test "$test_broken" != 0 || test "$test_fixed" != 0
821 then
822 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
823 msg="remaining $test_remaining test(s)"
Junio C Hamano11d54b82008-02-03 00:23:02 -0800824 else
Adam Spiersb73d9a22012-12-16 18:28:15 +0000825 test_remaining=$test_count
Junio C Hamano11d54b82008-02-03 00:23:02 -0800826 msg="$test_count test(s)"
Junio C Hamano41ac4142008-02-01 01:50:53 -0800827 fi
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700828 case "$test_failure" in
Junio C Hamano10b94e22005-12-09 17:32:18 -0800829 0)
Ramsay Jones1c0cc752012-09-01 19:11:49 +0100830 if test $test_external_has_tap -eq 0
831 then
Adam Spiersb73d9a22012-12-16 18:28:15 +0000832 if test $test_remaining -gt 0
Ramsay Jonesd87bd7c2012-09-01 19:26:21 +0100833 then
Thomas Rast633fe502013-10-19 23:06:08 +0200834 say_color pass "# passed all $msg"
Ramsay Jonesd87bd7c2012-09-01 19:26:21 +0100835 fi
Junio C Hamanoc7018be2017-05-18 11:52:20 +0900836
837 # Maybe print SKIP message
838 test -z "$skip_all" || skip_all="# SKIP $skip_all"
839 case "$test_count" in
840 0)
841 say "1..$test_count${skip_all:+ $skip_all}"
842 ;;
843 *)
844 test -z "$skip_all" ||
845 say_color warn "$skip_all"
846 say "1..$test_count"
847 ;;
848 esac
Ævar Arnfjörð Bjarmasond998bd42010-06-24 17:44:46 +0000849 fi
Johannes Schindelinabc5d372008-08-08 13:08:37 +0200850
Junio C Hamano06478da2017-04-23 17:15:09 -0700851 if test -z "$debug"
Junio C Hamano4d0912a2017-04-24 23:39:47 -0700852 then
Junio C Hamano06478da2017-04-23 17:15:09 -0700853 test -d "$TRASH_DIRECTORY" ||
Junio C Hamano4d0912a2017-04-24 23:39:47 -0700854 error "Tests passed but trash directory already removed before test cleanup; aborting"
Johannes Schindelinabc5d372008-08-08 13:08:37 +0200855
Junio C Hamano06478da2017-04-23 17:15:09 -0700856 cd "$TRASH_DIRECTORY/.." &&
857 rm -fr "$TRASH_DIRECTORY" ||
Junio C Hamano4d0912a2017-04-24 23:39:47 -0700858 error "Tests passed but test cleanup failed; aborting"
Junio C Hamano4d0912a2017-04-24 23:39:47 -0700859 fi
Thomas Rast342e9ef2012-02-17 11:25:09 +0100860 test_at_end_hook_
861
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700862 exit 0 ;;
863
864 *)
Ramsay Jones1c0cc752012-09-01 19:11:49 +0100865 if test $test_external_has_tap -eq 0
866 then
Thomas Rast633fe502013-10-19 23:06:08 +0200867 say_color error "# failed $test_failure among $msg"
868 say "1..$test_count"
Ævar Arnfjörð Bjarmasond998bd42010-06-24 17:44:46 +0000869 fi
Ævar Arnfjörð Bjarmason5099b992010-06-24 21:52:12 +0000870
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700871 exit 1 ;;
872
873 esac
874}
875
Matthew Ogilviee4597aa2009-12-02 22:14:06 -0700876if test -n "$valgrind"
Johannes Schindelin4e1be632009-02-04 00:25:59 +0100877then
Johannes Schindelin4e1be632009-02-04 00:25:59 +0100878 make_symlink () {
879 test -h "$2" &&
880 test "$1" = "$(readlink "$2")" || {
881 # be super paranoid
882 if mkdir "$2".lock
883 then
884 rm -f "$2" &&
885 ln -s "$1" "$2" &&
886 rm -r "$2".lock
887 else
888 while test -d "$2".lock
889 do
890 say "Waiting for lock on $2."
891 sleep 1
892 done
893 fi
894 }
895 }
896
897 make_valgrind_symlink () {
Jeff King36bfb0e2011-06-17 16:36:32 -0400898 # handle only executables, unless they are shell libraries that
Jonathan Nieder11d62142013-11-25 13:03:52 -0800899 # need to be in the exec-path.
Jeff King36bfb0e2011-06-17 16:36:32 -0400900 test -x "$1" ||
Ævar Arnfjörð Bjarmason2a59a6e2018-08-24 15:20:11 +0000901 test "# " = "$(test_copy_bytes 2 <"$1")" ||
Jeff King36bfb0e2011-06-17 16:36:32 -0400902 return;
Johannes Schindelin4e1be632009-02-04 00:25:59 +0100903
904 base=$(basename "$1")
René Scharfe28fab7b2016-10-28 00:14:00 +0200905 case "$base" in
906 test-*)
907 symlink_target="$GIT_BUILD_DIR/t/helper/$base"
908 ;;
909 *)
910 symlink_target="$GIT_BUILD_DIR/$base"
911 ;;
912 esac
Johannes Schindelin4e1be632009-02-04 00:25:59 +0100913 # do not override scripts
914 if test -x "$symlink_target" &&
915 test ! -d "$symlink_target" &&
Ævar Arnfjörð Bjarmason2a59a6e2018-08-24 15:20:11 +0000916 test "#!" != "$(test_copy_bytes 2 <"$symlink_target")"
Johannes Schindelin4e1be632009-02-04 00:25:59 +0100917 then
918 symlink_target=../valgrind.sh
919 fi
Johannes Schindelinefd92ff2009-02-04 00:26:08 +0100920 case "$base" in
921 *.sh|*.perl)
922 symlink_target=../unprocessed-script
923 esac
Johannes Schindelin4e1be632009-02-04 00:25:59 +0100924 # create the link, or replace it if it is out of date
925 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
926 }
927
Thomas Rast26a07302013-10-19 23:06:07 +0200928 # override all git executables in TEST_DIRECTORY/..
929 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
930 mkdir -p "$GIT_VALGRIND"/bin
Johannes Schindelin503e2242016-07-11 13:45:08 +0200931 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/t/helper/test-*
Thomas Rast26a07302013-10-19 23:06:07 +0200932 do
933 make_valgrind_symlink $file
934 done
935 # special-case the mergetools loadables
936 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
937 OLDIFS=$IFS
938 IFS=:
939 for path in $PATH
940 do
941 ls "$path"/git-* 2> /dev/null |
942 while read file
Johannes Schindelinefd92ff2009-02-04 00:26:08 +0100943 do
Thomas Rast26a07302013-10-19 23:06:07 +0200944 make_valgrind_symlink "$file"
Johannes Schindelinefd92ff2009-02-04 00:26:08 +0100945 done
Thomas Rast26a07302013-10-19 23:06:07 +0200946 done
947 IFS=$OLDIFS
Johannes Schindelin4e1be632009-02-04 00:25:59 +0100948 PATH=$GIT_VALGRIND/bin:$PATH
949 GIT_EXEC_PATH=$GIT_VALGRIND/bin
950 export GIT_VALGRIND
Thomas Rast952af352013-03-31 10:00:16 +0200951 GIT_VALGRIND_MODE="$valgrind"
952 export GIT_VALGRIND_MODE
Thomas Rast5dfc3682013-06-23 20:12:57 +0200953 GIT_VALGRIND_ENABLED=t
Thomas Rast26a07302013-10-19 23:06:07 +0200954 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
Thomas Rast5dfc3682013-06-23 20:12:57 +0200955 export GIT_VALGRIND_ENABLED
Ramsay Jones1c0cc752012-09-01 19:11:49 +0100956elif test -n "$GIT_TEST_INSTALLED"
957then
Matthew Ogilviee4597aa2009-12-02 22:14:06 -0700958 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
959 error "Cannot run git from $GIT_TEST_INSTALLED."
Ævar Arnfjörð Bjarmason6cec5c62010-08-19 16:08:10 +0000960 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
Matthew Ogilviee4597aa2009-12-02 22:14:06 -0700961 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
962else # normal case, use ../bin-wrappers only unless $with_dashes:
Ævar Arnfjörð Bjarmason6cec5c62010-08-19 16:08:10 +0000963 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
Ramsay Jones1c0cc752012-09-01 19:11:49 +0100964 if ! test -x "$git_bin_dir/git"
965 then
966 if test -z "$with_dashes"
967 then
Matthew Ogilviee4597aa2009-12-02 22:14:06 -0700968 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
969 fi
970 with_dashes=t
971 fi
972 PATH="$git_bin_dir:$PATH"
Ævar Arnfjörð Bjarmason6cec5c62010-08-19 16:08:10 +0000973 GIT_EXEC_PATH=$GIT_BUILD_DIR
Ramsay Jones1c0cc752012-09-01 19:11:49 +0100974 if test -n "$with_dashes"
975 then
Ævar Arnfjörð Bjarmason6cec5c62010-08-19 16:08:10 +0000976 PATH="$GIT_BUILD_DIR:$PATH"
Matthew Ogilviee4597aa2009-12-02 22:14:06 -0700977 fi
Johannes Schindelin4e1be632009-02-04 00:25:59 +0100978fi
Ævar Arnfjörð Bjarmason6cec5c62010-08-19 16:08:10 +0000979GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
Jeff King8bfa6bd2008-02-06 05:11:53 -0500980GIT_CONFIG_NOSYSTEM=1
Jonathan Nieder3c995be2011-03-15 04:05:10 -0500981GIT_ATTR_NOSYSTEM=1
Jonathan Nieder8f323c02011-03-15 04:04:49 -0500982export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
Junio C Hamano49ccb082005-12-07 21:52:28 -0800983
Junio C Hamano5e87eae2010-06-11 09:40:25 -0700984if test -z "$GIT_TEST_CMP"
985then
986 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
987 then
988 GIT_TEST_CMP="$DIFF -c"
989 else
990 GIT_TEST_CMP="$DIFF -u"
991 fi
992fi
993
Ævar Arnfjörð Bjarmason20d2a302017-12-10 21:13:33 +0000994GITPERLLIB="$GIT_BUILD_DIR"/perl/build/lib
Petr Baudis6fcca932006-07-03 23:16:32 +0200995export GITPERLLIB
Ævar Arnfjörð Bjarmason6cec5c62010-08-19 16:08:10 +0000996test -d "$GIT_BUILD_DIR"/templates/blt || {
Junio C Hamanoeea42062005-12-10 20:55:32 -0800997 error "You haven't built things yet, have you?"
998}
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700999
Nguyễn Thái Ngọc Duy0e496492018-03-24 08:44:31 +01001000if ! test -x "$GIT_BUILD_DIR"/t/helper/test-tool
Ramsay Jones1c0cc752012-09-01 19:11:49 +01001001then
Nguyễn Thái Ngọc Duy0e496492018-03-24 08:44:31 +01001002 echo >&2 'You need to build test-tool:'
1003 echo >&2 'Run "make t/helper/test-tool" in the source (toplevel) directory'
Eric Wong56cf9802007-02-24 16:59:52 -08001004 exit 1
1005fi
1006
Junio C Hamanoe1970ce2005-05-13 22:50:32 -07001007# Test repository
Jeff King002d4ce2013-04-14 15:38:21 -04001008TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
1009test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
1010case "$TRASH_DIRECTORY" in
1011/*) ;; # absolute path is good
1012 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
Jeff Kingf423ef52009-08-09 04:39:45 -04001013esac
John Keeping38b074d2013-04-14 17:34:56 +01001014rm -fr "$TRASH_DIRECTORY" || {
Clemens Buchacher6e7b5aa2009-06-01 14:14:41 +02001015 GIT_EXIT_OK=t
Junio C Hamano8d14ac92008-03-18 21:58:01 -07001016 echo >&5 "FATAL: Cannot prepare test area"
1017 exit 1
1018}
1019
Alex Riesen90cff962011-03-26 19:46:34 +01001020HOME="$TRASH_DIRECTORY"
Junio C Hamano0ea47f92014-09-15 14:59:00 -07001021GNUPGHOME="$HOME/gnupg-home-not-used"
1022export HOME GNUPGHOME
Alex Riesen90cff962011-03-26 19:46:34 +01001023
Ramsay Jones1c0cc752012-09-01 19:11:49 +01001024if test -z "$TEST_NO_CREATE_REPO"
1025then
John Keeping38b074d2013-04-14 17:34:56 +01001026 test_create_repo "$TRASH_DIRECTORY"
Thomas Rast342e9ef2012-02-17 11:25:09 +01001027else
John Keeping38b074d2013-04-14 17:34:56 +01001028 mkdir -p "$TRASH_DIRECTORY"
Thomas Rast342e9ef2012-02-17 11:25:09 +01001029fi
Lea Wiemann1bd9c642008-05-31 23:11:21 +02001030# Use -P to resolve symlinks in our working directory so that the cwd
1031# in subprocesses like git equals our $PWD (for pathname comparisons).
John Keeping38b074d2013-04-14 17:34:56 +01001032cd -P "$TRASH_DIRECTORY" || exit 1
Junio C Hamano04ece592006-12-28 17:58:00 -08001033
Johannes Sixtd5d9de12009-02-05 20:59:27 +01001034this_test=${0##*/}
1035this_test=${this_test%%-*}
Thomas Raste6a6ddc2013-06-18 14:25:58 +02001036if match_pattern_list "$this_test" $GIT_SKIP_TESTS
1037then
1038 say_color info >&3 "skipping test $this_test altogether"
1039 skip_all="skip all tests in $this_test"
1040 test_done
1041fi
Johannes Sixtf17e9fb2009-03-11 21:17:26 +01001042
Brandon Casey86487322009-08-28 17:32:41 -05001043# Provide an implementation of the 'yes' utility
1044yes () {
1045 if test $# = 0
1046 then
1047 y=y
1048 else
1049 y="$*"
1050 fi
1051
Johannes Schindelin6129c932016-02-02 19:15:53 +01001052 i=0
1053 while test $i -lt 99
Brandon Casey86487322009-08-28 17:32:41 -05001054 do
Johannes Schindelin6129c932016-02-02 19:15:53 +01001055 echo "$y"
1056 i=$(($i+1))
Brandon Casey86487322009-08-28 17:32:41 -05001057 done
1058}
1059
Johannes Sixtf17e9fb2009-03-11 21:17:26 +01001060# Fix some commands on Windows
Johannes Schindelind98b2c52016-07-21 18:02:54 +02001061uname_s=$(uname -s)
1062case $uname_s in
Johannes Sixtf17e9fb2009-03-11 21:17:26 +01001063*MINGW*)
1064 # Windows has its own (incompatible) sort and find
1065 sort () {
1066 /usr/bin/sort "$@"
1067 }
1068 find () {
1069 /usr/bin/find "$@"
1070 }
Johannes Sixt41141562009-03-13 23:35:24 +01001071 # git sees Windows-style pwd
1072 pwd () {
1073 builtin pwd -W
1074 }
Johannes Sixtee9fb682009-03-13 22:55:27 +01001075 # no POSIX permissions
Johannes Sixt6fd11062009-03-13 23:00:15 +01001076 # backslashes in pathspec are converted to '/'
Johannes Sixtfb9a2be2009-03-25 13:21:15 +01001077 # exec does not inherit the PID
Pat Thoytsa94114a2010-09-12 10:37:24 +01001078 test_set_prereq MINGW
Brice Lambson5f4e02e2014-08-30 23:39:07 +02001079 test_set_prereq NATIVE_CRLF
Ramsay Jonesa31d0662010-12-14 18:32:12 +00001080 test_set_prereq SED_STRIPS_CR
Mark Levedahl97669ee2013-07-18 17:44:57 -04001081 test_set_prereq GREP_STRIPS_CR
Johannes Sixt4d715ac2013-10-26 21:17:15 +02001082 GIT_TEST_CMP=mingw_test_cmp
Ramsay Jonesa31d0662010-12-14 18:32:12 +00001083 ;;
1084*CYGWIN*)
1085 test_set_prereq POSIXPERM
Ramsay Jonesa31d0662010-12-14 18:32:12 +00001086 test_set_prereq EXECKEEPSPID
Pete Wyckoffcfa96492013-01-26 22:11:11 -05001087 test_set_prereq CYGWIN
Ramsay Jonesa31d0662010-12-14 18:32:12 +00001088 test_set_prereq SED_STRIPS_CR
Mark Levedahl97669ee2013-07-18 17:44:57 -04001089 test_set_prereq GREP_STRIPS_CR
Johannes Sixtee9fb682009-03-13 22:55:27 +01001090 ;;
1091*)
1092 test_set_prereq POSIXPERM
Johannes Sixt6fd11062009-03-13 23:00:15 +01001093 test_set_prereq BSLASHPSPEC
Johannes Sixtfb9a2be2009-03-25 13:21:15 +01001094 test_set_prereq EXECKEEPSPID
Johannes Sixtf17e9fb2009-03-11 21:17:26 +01001095 ;;
1096esac
Johannes Sixt704a3142009-03-04 22:38:24 +01001097
Zbigniew Jędrzejewski-Szmekb0826872012-04-27 11:25:25 +02001098( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
Jeff King1b19ccd2009-04-03 15:33:59 -04001099test -z "$NO_PERL" && test_set_prereq PERL
Ævar Arnfjörð Bjarmason68c7d272017-05-25 19:45:31 +00001100test -z "$NO_PTHREADS" && test_set_prereq PTHREADS
Johan Herlandd4e1b472009-11-18 02:42:31 +01001101test -z "$NO_PYTHON" && test_set_prereq PYTHON
Ævar Arnfjörð Bjarmason94da9192017-06-01 18:20:56 +00001102test -n "$USE_LIBPCRE1$USE_LIBPCRE2" && test_set_prereq PCRE
Ævar Arnfjörð Bjarmasonce9a2572017-11-23 14:16:57 +00001103test -n "$USE_LIBPCRE1" && test_set_prereq LIBPCRE1
1104test -n "$USE_LIBPCRE2" && test_set_prereq LIBPCRE2
Ævar Arnfjörð Bjarmason5e9637c2011-11-18 00:14:42 +01001105test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
Jeff King1b19ccd2009-04-03 15:33:59 -04001106
Ævar Arnfjörð Bjarmasonbb946bb2011-02-22 23:41:21 +00001107# Can we rely on git's output in the C locale?
Jonathan Nieder30955222011-02-22 23:41:22 +00001108if test -n "$GETTEXT_POISON"
1109then
1110 GIT_GETTEXT_POISON=YesPlease
1111 export GIT_GETTEXT_POISON
Ævar Arnfjörð Bjarmason5e9637c2011-11-18 00:14:42 +01001112 test_set_prereq GETTEXT_POISON
Jonathan Nieder30955222011-02-22 23:41:22 +00001113else
1114 test_set_prereq C_LOCALE_OUTPUT
1115fi
Ævar Arnfjörð Bjarmasonbb946bb2011-02-22 23:41:21 +00001116
Nguyễn Thái Ngọc Duy4592e602018-08-18 16:41:28 +02001117if test -z "$GIT_TEST_CHECK_CACHE_TREE"
1118then
1119 GIT_TEST_CHECK_CACHE_TREE=true
1120 export GIT_TEST_CHECK_CACHE_TREE
1121fi
1122
Adam Spiers20073272013-04-11 03:07:04 +01001123test_lazy_prereq PIPE '
1124 # test whether the filesystem supports FIFOs
Ramsay Jones7b7bea22017-09-17 23:56:00 +01001125 test_have_prereq !MINGW,!CYGWIN &&
1126 rm -f testfifo && mkfifo testfifo
Adam Spiers20073272013-04-11 03:07:04 +01001127'
1128
Junio C Hamano04083f22012-07-26 15:50:45 -07001129test_lazy_prereq SYMLINKS '
1130 # test whether the filesystem supports symbolic links
1131 ln -s x y && test -h y
1132'
Ævar Arnfjörð Bjarmasonc91cfd12010-08-06 22:09:09 +00001133
Jonathan Niederb018c732013-11-25 13:02:16 -08001134test_lazy_prereq FILEMODE '
1135 test "$(git config --bool core.filemode)" = true
1136'
1137
Michael J Gruberac39aa62012-07-26 15:39:53 +02001138test_lazy_prereq CASE_INSENSITIVE_FS '
1139 echo good >CamelCase &&
1140 echo bad >camelcase &&
1141 test "$(cat CamelCase)" != good
1142'
1143
William Chargin6ec63302018-08-06 11:35:08 -07001144test_lazy_prereq FUNNYNAMES '
1145 test_have_prereq !MINGW &&
1146 touch -- \
1147 "FUNNYNAMES tab embedded" \
1148 "FUNNYNAMES \"quote embedded\"" \
1149 "FUNNYNAMES newline
1150embedded" 2>/dev/null &&
1151 rm -- \
1152 "FUNNYNAMES tab embedded" \
1153 "FUNNYNAMES \"quote embedded\"" \
1154 "FUNNYNAMES newline
1155embedded" 2>/dev/null
1156'
1157
Michael J Gruber5b0b5dd2012-07-26 15:39:56 +02001158test_lazy_prereq UTF8_NFD_TO_NFC '
1159 # check whether FS converts nfd unicode to nfc
1160 auml=$(printf "\303\244")
1161 aumlcdiar=$(printf "\141\314\210")
1162 >"$auml" &&
Torsten Bögershausen742ae102018-04-30 08:35:19 +02001163 test -f "$aumlcdiar"
Michael J Gruber5b0b5dd2012-07-26 15:39:56 +02001164'
1165
Jeff King09feffb2012-11-14 16:33:40 -08001166test_lazy_prereq AUTOIDENT '
1167 sane_unset GIT_AUTHOR_NAME &&
1168 sane_unset GIT_AUTHOR_EMAIL &&
1169 git var GIT_AUTHOR_IDENT
1170'
1171
Junio C Hamano6219bb22014-06-09 12:23:30 -07001172test_lazy_prereq EXPENSIVE '
1173 test -n "$GIT_TEST_LONG"
1174'
1175
Ævar Arnfjörð Bjarmason5b1fe6e2018-01-30 21:21:23 +00001176test_lazy_prereq EXPENSIVE_ON_WINDOWS '
1177 test_have_prereq EXPENSIVE || test_have_prereq !MINGW,!CYGWIN
1178'
1179
Junio C Hamanoe1ecd9e2014-06-09 13:54:25 -07001180test_lazy_prereq USR_BIN_TIME '
1181 test -x /usr/bin/time
1182'
1183
Jeff King1767c512015-01-16 04:16:49 -05001184test_lazy_prereq NOT_ROOT '
1185 uid=$(id -u) &&
1186 test "$uid" != 0
1187'
1188
Jonathan Tan63b747c2016-09-09 10:36:28 -07001189test_lazy_prereq JGIT '
1190 type jgit
1191'
1192
Junio C Hamano719c3da2016-01-19 14:09:37 -08001193# SANITY is about "can you correctly predict what the filesystem would
1194# do by only looking at the permission bits of the files and
1195# directories?" A typical example of !SANITY is running the test
1196# suite as root, where a test may expect "chmod -r file && cat file"
1197# to fail because file is supposed to be unreadable after a successful
1198# chmod. In an environment (i.e. combination of what filesystem is
1199# being used and who is running the tests) that lacks SANITY, you may
1200# be able to delete or create a file when the containing directory
1201# doesn't have write permissions, or access a file even if the
1202# containing directory doesn't have read or execute permissions.
1203
Torsten Bögershausenf400e512015-01-27 16:39:01 +01001204test_lazy_prereq SANITY '
1205 mkdir SANETESTD.1 SANETESTD.2 &&
1206
1207 chmod +w SANETESTD.1 SANETESTD.2 &&
1208 >SANETESTD.1/x 2>SANETESTD.2/x &&
1209 chmod -w SANETESTD.1 &&
Junio C Hamano719c3da2016-01-19 14:09:37 -08001210 chmod -r SANETESTD.1/x &&
Torsten Bögershausenf400e512015-01-27 16:39:01 +01001211 chmod -rx SANETESTD.2 ||
1212 error "bug in test sript: cannot prepare SANETESTD"
1213
Junio C Hamano719c3da2016-01-19 14:09:37 -08001214 ! test -r SANETESTD.1/x &&
Torsten Bögershausenf400e512015-01-27 16:39:01 +01001215 ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1216 status=$?
1217
1218 chmod +rwx SANETESTD.1 SANETESTD.2 &&
1219 rm -rf SANETESTD.1 SANETESTD.2 ||
1220 error "bug in test sript: cannot clean SANETESTD"
1221 return $status
1222'
Jeff Kingf838ce52013-03-10 21:31:47 -04001223
Johannes Schindelind98b2c52016-07-21 18:02:54 +02001224test FreeBSD != $uname_s || GIT_UNZIP=${GIT_UNZIP:-/usr/local/bin/unzip}
Jeff Kingf838ce52013-03-10 21:31:47 -04001225GIT_UNZIP=${GIT_UNZIP:-unzip}
1226test_lazy_prereq UNZIP '
1227 "$GIT_UNZIP" -v
1228 test $? -ne 127
1229'
Jeff King9a308de2015-03-13 00:53:07 -04001230
1231run_with_limited_cmdline () {
1232 (ulimit -s 128 && "$@")
1233}
1234
Ramsay Jones21dac1d2017-09-14 18:24:41 +01001235test_lazy_prereq CMDLINE_LIMIT '
1236 test_have_prereq !MINGW,!CYGWIN &&
1237 run_with_limited_cmdline true
1238'
Jeff King6b9c38e2016-07-11 19:54:18 -04001239
Michael J Gruber4db464f2017-09-07 16:02:20 +02001240run_with_limited_stack () {
1241 (ulimit -s 128 && "$@")
1242}
1243
Ramsay Jones21dac1d2017-09-14 18:24:41 +01001244test_lazy_prereq ULIMIT_STACK_SIZE '
1245 test_have_prereq !MINGW,!CYGWIN &&
1246 run_with_limited_stack true
1247'
Michael J Gruber4db464f2017-09-07 16:02:20 +02001248
Jeff King6b9c38e2016-07-11 19:54:18 -04001249build_option () {
1250 git version --build-options |
1251 sed -ne "s/^$1: //p"
1252}
1253
1254test_lazy_prereq LONG_IS_64BIT '
1255 test 8 -le "$(build_option sizeof-long)"
1256'
Johannes Schindelina07fb052017-04-20 22:52:13 +02001257
Nguyễn Thái Ngọc Duya801a7c2018-03-24 08:44:36 +01001258test_lazy_prereq TIME_IS_64BIT 'test-tool date is64bit'
1259test_lazy_prereq TIME_T_IS_64BIT 'test-tool date time_t-is64bit'
Jeff Kinge9184b02018-04-03 10:01:57 -04001260
1261test_lazy_prereq CURL '
1262 curl --version
1263'
brian m. carlsond16ab632018-05-13 02:24:11 +00001264
1265# SHA1 is a test if the hash algorithm in use is SHA-1. This is both for tests
1266# which will not work with other hash algorithms and tests that work but don't
1267# test anything meaningful (e.g. special values which cause short collisions).
1268test_lazy_prereq SHA1 '
1269 test $(git hash-object /dev/null) = e69de29bb2d1d6434b8b29ae775ad8c2e48c5391
1270'